const ИМЯ_МОДУЛЯ_РЕСУРСОВ = "Ресурсы Маджонга | Mahjong resources";
const ИМЯ_ОТЛ_РАСКЛАДКИ = "Отладочные раскладки Маджонга | Mahjong debug layouts";

// // // //


УведомитьОЗагрузкеРесурсовСцены = мир =>
{
    мир.уведомить("загрузили ресурсы сцены");
};


// // // //


ЗадатьОтладочнуюТемуФишекДляЗагрузки = мир =>
{
    мир.темаФишек = "отладочная|debug";
};


// // // //


ЗагрузитьВыбраннуюРаскладку = мир =>
{
    var имяМодуля = ИМЯ_МОДУЛЯ_РЕСУРСОВ;
    var ресурс = "/X_shaped.layout";
    if (мир.выбраннаяРаскладка == "😀")
    {
        ресурс = "/успех|success.layout";
        имяМодуля = ИМЯ_ОТЛ_РАСКЛАДКИ;
    }
    else if (мир.выбраннаяРаскладка == "😭")
    {
        ресурс = "/провал|failure.layout";
        имяМодуля = ИМЯ_ОТЛ_РАСКЛАДКИ;
    }
    var модуль = мир.модули.модульПоИмени(имяМодуля);
    var содержимое = модуль.содержимое[ресурс];
    мир.раскладкаKMahjongg = {
        "содержимое": содержимое,
    };
};


// // // //


ЗагрузитьФишку = мир =>
{
    var модуль = мир.модули.модульПоИмени(ИМЯ_МОДУЛЯ_РЕСУРСОВ);
    var ресурс = "/фишка.gltf";
    var адрес = `${window.location.origin}${ресурс}`;
    THREE.Cache.enabled = true;
    THREE.Cache.add(адрес, модуль.содержимое[ресурс]);
    мир.загрузчикGLTF.load(
        адрес,
        function(gltf) {
            // Вычленяем Mesh.
            gltf.scene.traverse(function(ребёнок) {
                if (ребёнок.isMesh)
                {
                    мир.фишка = ребёнок;
                }
            });
            мир.уведомить("загрузили фишку");
        },
        null,
        function(error) {
            console.error("ОШИБКА | ERROR", error);
        }
    );
};

